#include <gmpxx.h>
#include <string>

const mpz_class pow(const mpz_class& base, const mpz_class& exponent)
{
	if(exponent==0)
	{
		return 1;
	}

	mpz_class counter=0, ret_val=1;
	while(!(counter==exponent))
	{
		ret_val*=base;
		++counter;
	}

	return ret_val;
}
const mpz_class permutations(unsigned int n, unsigned int r)
{
	if(r<=0)
	{
		return mpz_class(1);
	}
	if(r>n)
	{
		return mpz_class(0);
	}

	mpz_class result=1;
	mpz_class multiplier=n-r+1;
	for(int i=n-r+1; i<=n; ++i)
	{
		result*=multiplier;
		++multiplier;
	}
	return result;
}

std::string mpzToString(mpz_class &value)
{
	char *temp;
	temp = mpz_get_str(0, 10, value.get_mpz_t());
	std::string output(temp);

	return output;
}
