#include <fstream>
#include <iostream>
#include <iterator>
#include <list>
#include <vector>

#include "stats.hpp"
tm_stats g_counter, c_counter;

#include "infinite_tape.hpp"
#include "long_int.hpp"
#include "state.hpp"
#include "turing_machine.hpp"
#include "non_halt_detection.hpp"
#include "non_halt_data_structures.hpp"
#include "machine_storage.hpp"
#include "watch.hpp"

int main()
{
	turing_machine<unsigned short> machine(5,0);

	machine.set_halt_state(4);

	machine.add_write_transition(0,0,1,1);
	machine.add_move_transition(0,1, turing_machine<unsigned short>::left, 1);
	machine.add_move_transition(1,0, turing_machine<unsigned short>::left, 1);
	machine.add_move_transition(1,1, turing_machine<unsigned short>::right, 2);
	machine.add_move_transition(2,0, turing_machine<unsigned short>::right, 3);
	machine.add_write_transition(3,0,1,0);
	machine.add_write_transition(3,1,0,2);

	if(counter(machine, 1500))
		std::cout << "yes" << std::endl << std::endl;

	turing_machine<unsigned short> machine2(6,0);

	machine2.set_halt_state(5);

	machine2.add_write_transition(0,0,1,1);
	machine2.add_write_transition(1,0,1,2);
	machine2.add_move_transition(1,1, turing_machine<unsigned short>::right, 1);
	machine2.add_move_transition(2,0, turing_machine<unsigned short>::left, 4);
	machine2.add_move_transition(2,1, turing_machine<unsigned short>::left, 3);
	machine2.add_write_transition(3,1,0,2);
	machine2.add_move_transition(4,0, turing_machine<unsigned short>::right, 0);
	machine2.add_write_transition(4,1,0,2);

	if(counter(machine2, 1500))
		std::cout << "yes" << std::endl << std::endl;

	//machine2.printTMO(std::cout);
	//machine2.reverseMachine().printTMO(std::cout);

	turing_machine<unsigned short> machine3(6,0);

	machine3.set_halt_state(5);

	machine3.add_write_transition(0,0,1,0);
	machine3.add_move_transition(0,1, turing_machine<unsigned short>::right,1);
	machine3.add_move_transition(1,0, turing_machine<unsigned short>::right, 2);
	machine3.add_write_transition(2,0,1,3);
	machine3.add_write_transition(2,1,0,1);
	machine3.add_move_transition(3,0, turing_machine<unsigned short>::left, 4);
	machine3.add_move_transition(3,1, turing_machine<unsigned short>::left, 3);
	machine3.add_move_transition(4,0, turing_machine<unsigned short>::left, 4);
	machine3.add_move_transition(4,1, turing_machine<unsigned short>::right, 1);

	if(counter(machine3, 1500))
		std::cout << "yes" << std::endl << std::endl;

	return 0;
}
